Bug 1332307 - Review Request: libcxx - C++ standard library targeting C++11
Summary: Review Request: libcxx - C++ standard library targeting C++11
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1332306
TreeView+ depends on / blocked
 
Reported: 2016-05-02 20:44 UTC by Tom "spot" Callaway
Modified: 2016-06-24 18:53 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-06-15 23:21:06 UTC
anto.trande: fedora-review+


Attachments (Terms of Use)

Description Tom "spot" Callaway 2016-05-02 20:44:54 UTC
Spec URL: https://spot.fedorapeople.org/libcxx.spec
SRPM URL: https://spot.fedorapeople.org/libcxx-20160502-2.svn268289.fc24.src.rpm
Description: libc++ is a new implementation of the C++ standard library, targeting C++11.
Fedora Account System Username: spot

Note: Upstream has no versioning system that I can see, does no 'releases'. I need this package to support C++11 in R in EPEL. Also note, this package has a bootstrap cycle with libcxxabi.

Comment 1 Robin Lee 2016-05-03 03:31:59 UTC
libcxx was released together with LLVM. The versioned tarball can be found here:
http://llvm.org/releases/3.8.0/libcxx-3.8.0.src.tar.xz

Comment 2 Tom "spot" Callaway 2016-05-03 13:18:04 UTC
(In reply to Robin Lee from comment #1)
> libcxx was released together with LLVM. The versioned tarball can be found
> here:
> http://llvm.org/releases/3.8.0/libcxx-3.8.0.src.tar.xz

Thanks! I'll fix that immediately.

Comment 3 Tom "spot" Callaway 2016-05-03 13:28:34 UTC
New Spec: https://spot.fedorapeople.org/libcxx.spec
New SRPM: https://spot.fedorapeople.org/libcxx-3.8.0-2.fc24.src.rpm

Technically, I should have put an epoch here, but since it is SUPER unlikely anyone besides me and maybe Robin used the previous svn-based package, I left it out.

Comment 4 Robin Lee 2016-05-04 02:53:44 UTC
The package builds on Fedora 24, but not any earlier versions.
On Fedora 22/23, if _FORTIFY_SOURCE is used (the default), it fails to build[1]. So if this package is getting to Fedora 22/23, you may have to remove _FORTIFY_SOURCE or build it with GCC.

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1188075

Comment 5 Tom "spot" Callaway 2016-05-19 18:11:25 UTC
It is uglier than that. Removing _FORTIFY_SOURCE makes it build a bit farther, but clang 3.7.0 (f23) just crashes all over itself.

Comment 6 Tom "spot" Callaway 2016-05-19 18:51:48 UTC
A few scratch builds later, this is the build matrix:
    clang     gcc
EL6  Yes       No
EL7  No        Yes
F22  No        Yes
F23  No        Yes
F24  Yes       Yes
F25  Yes       Yes

Since we really do want to use clang here when we can, I've conditionalized accordingly. I also do not care about EL5 at this point. :)

New SRPM: https://spot.fedorapeople.org/libcxx-3.8.0-3.fc24.src.rpm
New SPEC: https://spot.fedorapeople.org/libcxx.spec

Comment 7 Antonio 2016-05-29 15:57:39 UTC
- I see this warning on Fedora 25 64bit:

-- Found LLVM_CONFIG as /usr/bin/llvm-config
CMake Warning at cmake/Modules/HandleOutOfTreeLLVM.cmake:46 (message):
  Not found: /builddir/build/BUILD/llvm-3.8.0.src
Call Stack (most recent call first):
  cmake/Modules/HandleOutOfTreeLLVM.cmake:67 (find_llvm_parts)
  CMakeLists.txt:37 (include)
CMake Warning at CMakeLists.txt:39 (message):
  UNSUPPORTED LIBCXX CONFIGURATION DETECTED: llvm-config not found and
  LLVM_PATH not defined.
  Reconfigure with -DLLVM_CONFIG=path/to/llvm-config or
  -DLLVM_PATH=path/to/llvm-source-root.

On 64 bit systems, llvm-config looks not available; it's llvm-config-64.

- Flags for hardened_builds are not used with clang.

- Why do you not perform tests ?

Comment 8 Tom "spot" Callaway 2016-06-01 17:57:36 UTC
(In reply to Antonio Trande from comment #7)
> - I see this warning on Fedora 25 64bit:
> 
> -- Found LLVM_CONFIG as /usr/bin/llvm-config
> CMake Warning at cmake/Modules/HandleOutOfTreeLLVM.cmake:46 (message):
>   Not found: /builddir/build/BUILD/llvm-3.8.0.src
> Call Stack (most recent call first):
>   cmake/Modules/HandleOutOfTreeLLVM.cmake:67 (find_llvm_parts)
>   CMakeLists.txt:37 (include)
> CMake Warning at CMakeLists.txt:39 (message):
>   UNSUPPORTED LIBCXX CONFIGURATION DETECTED: llvm-config not found and
>   LLVM_PATH not defined.
>   Reconfigure with -DLLVM_CONFIG=path/to/llvm-config or
>   -DLLVM_PATH=path/to/llvm-source-root.
> 
> On 64 bit systems, llvm-config looks not available; it's llvm-config-64.

Yes, but alternatives makes a symlink to llvm-config, so it is safe to always call that.

> - Flags for hardened_builds are not used with clang.

Yes, but they're also safely ignored by clang.

> - Why do you not perform tests ?

Couldn't figure out how to run them, think it might require a full llvm source tree.

Comment 9 Antonio 2016-06-01 18:31:34 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== Issues =====

- /usr/include/c++ should be co-owned with libstdc++-devel.

- rpmlint shows various 'undefined-non-weak-symbol' warnings.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)", "Unknown or generated". 5265 files have
     unknown license. Detailed output of licensecheck in
     /home/sagitter/1332307-libcxx/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/include/c++(libstdc++-devel)
[x]: %build honors applicable compiler flags or justifies otherwise.
     (hardened_build flags safely ignored by clang)
   
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in libcxx-
     debuginfo
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libcxx-3.8.0-3.fc25.x86_64.rpm
          libcxx-devel-3.8.0-3.fc25.x86_64.rpm
          libcxx-debuginfo-3.8.0-3.fc25.x86_64.rpm
          libcxx-3.8.0-3.fc25.src.rpm
libcxx.x86_64: W: spelling-error %description -l en_US libc -> lib, lib c
libcxx-devel.x86_64: W: only-non-binary-in-usr-lib
libcxx-devel.x86_64: W: no-documentation
libcxx.src: W: spelling-error %description -l en_US libc -> lib, lib c
4 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libcxx-debuginfo-3.8.0-3.fc25.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
libcxx.x86_64: W: spelling-error %description -l en_US libc -> lib, lib c
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_pure_virtual
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 vtable for __cxxabiv1::__class_type_info
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 vtable for __cxxabiv1::__vmi_class_type_info
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 vtable for __cxxabiv1::__si_class_type_info
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __gxx_personality_v0
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_end_catch
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_allocate_exception
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_guard_release
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_begin_catch
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_rethrow
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_throw
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_guard_abort
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_call_unexpected
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_free_exception
libcxx.x86_64: W: undefined-non-weak-symbol /usr/lib64/libc++.so.1.0 __cxa_guard_acquire
libcxx.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libc++.so.1.0 /lib64/libm.so.6
libcxx.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libc++.so.1.0 /lib64/librt.so.1
libcxx-devel.x86_64: W: only-non-binary-in-usr-lib
libcxx-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 20 warnings.



Requires
--------
libcxx (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    rtld(GNU_HASH)

libcxx-devel (rpmlib, GLIBC filtered):
    libc++.so.1()(64bit)
    libcxx(x86-64)

libcxx-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
libcxx:
    libc++.so.1()(64bit)
    libcxx
    libcxx(x86-64)

libcxx-devel:
    libcxx-devel
    libcxx-devel(x86-64)

libcxx-debuginfo:
    libcxx-debuginfo
    libcxx-debuginfo(x86-64)



Source checksums
----------------
http://llvm.org/releases/3.8.0/libcxx-3.8.0.src.tar.xz :
  CHECKSUM(SHA256) this package     : 36804511b940bc8a7cefc7cb391a6b28f5e3f53f6372965642020db91174237b
  CHECKSUM(SHA256) upstream package : 36804511b940bc8a7cefc7cb391a6b28f5e3f53f6372965642020db91174237b


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1332307
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 10 Tom "spot" Callaway 2016-06-01 18:39:38 UTC
- /usr/include/c++ should be co-owned with libstdc++-devel

... and it is! 

The weak symbols are okay to ignore. They're all in libcxxabi.

Comment 11 Antonio 2016-06-01 18:43:16 UTC
(In reply to Tom "spot" Callaway from comment #10)
> - /usr/include/c++ should be co-owned with libstdc++-devel
> 
> ... and it is!

Yes, explicitely I meant.

> 
> The weak symbols are okay to ignore. They're all in libcxxabi.

Okay.

Package approved.

Comment 12 Tom "spot" Callaway 2016-06-01 18:47:58 UTC
(In reply to Antonio Trande from comment #11)
> (In reply to Tom "spot" Callaway from comment #10)
> > - /usr/include/c++ should be co-owned with libstdc++-devel
> > 
> > ... and it is!
> 
> Yes, explicitely I meant.

I'm not sure what you mean there, but you approved the package. :) Thanks for the review!

Comment 13 Antonio 2016-06-01 19:23:37 UTC
(In reply to Tom "spot" Callaway from comment #12)
> (In reply to Antonio Trande from comment #11)
> > (In reply to Tom "spot" Callaway from comment #10)
> > > - /usr/include/c++ should be co-owned with libstdc++-devel
> > > 
> > > ... and it is!
> > 
> > Yes, explicitely I meant.
> 
> I'm not sure what you mean there, but you approved the package. :) Thanks
> for the review!

%dir /usr/include/c++
/usr/include/c++/v1/

Comment 14 Tom "spot" Callaway 2016-06-01 19:25:39 UTC
(In reply to Antonio Trande from comment #13)

> %dir /usr/include/c++
> /usr/include/c++/v1/

%{_includedir}/c++/

 is identical to

%dir %{_includedir}/c++
%{_includedir}/c++/v1/

Comment 15 Gwyn Ciesla 2016-06-03 16:38:27 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/libcxx

Comment 16 Fedora Update System 2016-06-06 17:50:50 UTC
libcxx-3.8.0-3.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0146d17f3b

Comment 17 Fedora Update System 2016-06-06 17:50:58 UTC
libcxx-3.8.0-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-4224792a98

Comment 18 Fedora Update System 2016-06-06 17:51:04 UTC
libcxx-3.8.0-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-70a8dcb27f

Comment 19 Fedora Update System 2016-06-06 17:51:09 UTC
libcxx-3.8.0-3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-280808acac

Comment 20 Fedora Update System 2016-06-06 17:51:15 UTC
libcxx-3.8.0-3.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9f912a4d07

Comment 21 Fedora Update System 2016-06-07 18:54:33 UTC
libcxx-3.8.0-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-4224792a98

Comment 22 Fedora Update System 2016-06-08 02:23:50 UTC
libcxx-3.8.0-3.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0146d17f3b

Comment 23 Fedora Update System 2016-06-08 02:24:28 UTC
libcxx-3.8.0-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-70a8dcb27f

Comment 24 Fedora Update System 2016-06-08 05:48:07 UTC
libcxx-3.8.0-3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-280808acac

Comment 25 Fedora Update System 2016-06-08 05:48:48 UTC
libcxx-3.8.0-3.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9f912a4d07

Comment 26 Fedora Update System 2016-06-09 13:21:15 UTC
libcxx-3.8.0-4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-916f868a7c

Comment 27 Fedora Update System 2016-06-09 16:55:17 UTC
libcxx-3.8.0-4.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-916f868a7c

Comment 28 Fedora Update System 2016-06-15 23:21:03 UTC
libcxx-3.8.0-3.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 29 Fedora Update System 2016-06-15 23:25:32 UTC
libcxx-3.8.0-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 30 Fedora Update System 2016-06-23 02:18:37 UTC
libcxx-3.8.0-3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Comment 31 Fedora Update System 2016-06-23 02:18:42 UTC
libcxx-3.8.0-3.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 32 Fedora Update System 2016-06-24 18:53:58 UTC
libcxx-3.8.0-4.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.